org.apache.sysds.hops.codegen

## Class SpoofFusedOp

- java.lang.Object
- - org.apache.sysds.hops.Hop
  - - org.apache.sysds.hops.MultiThreadedHop
    - - org.apache.sysds.hops.codegen.SpoofFusedOp

- All Implemented Interfaces:
    ParseInfo

      public class SpoofFusedOp
      extends MultiThreadedHop

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SpoofFusedOp.SpoofOutputDimsType`

  - ### Field Summary

    - ### Fields inherited from class org.apache.sysds.hops.Hop

      `_beginColumn, _beginLine, _endColumn, _endLine, _filename, _text, CPThreshold`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SpoofFusedOp()`
    `SpoofFusedOp(String name, Types.DataType dt, Types.ValueType vt, Class<?> cla, SpoofCompiler.GeneratorAPI api, String genVarName, boolean dist, SpoofFusedOp.SpoofOutputDimsType type)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `allowsAllExecTypes()`
    `void` | `checkArity()` Check whether this Hop has a correct number of inputs.
    `Object` | `clone()`
    `boolean` | `compare(Hop that)`
    `Lop` | `constructLops()`
    `String` | `getClassName()`
    `String` | `getOpString()`
    `boolean` | `isGPUEnabled()` In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop.
    `boolean` | `isMultiThreadedOpType()`
    `void` | `refreshSizeInformation()` Update the output size information for this hop.
    `void` | `setConstDim2(long constDim2)`

    - ### Methods inherited from class org.apache.sysds.hops.MultiThreadedHop

      `getMaxNumThreads, setMaxNumThreads`

    - ### Methods inherited from class org.apache.sysds.hops.Hop

      `addAllInputs, addInput, checkAndSetForcedPlatform, checkAndSetInvalidCPDimsAndSize, clearMemEstimate, colsKnown, compressedSize, computeBoundsInformation, computeBoundsInformation, computeBoundsInformation, computeMemEstimate, computeSizeInformation, computeSizeInformation, computeSizeInformation, constructAndSetLopsDataFlowProperties, createOffsetLop, dimsKnown, dimsKnown, dimsKnownAny, getBeginColumn, getBeginLine, getBlocksize, getCompressedSize, getDataCharacteristics, getDataType, getDim, getDim1, getDim2, getEndColumn, getEndLine, getExecType, getFilename, getForcedExecType, getHopID, getInput, getInput, getInputMemEstimate, getInputOutputSize, getIntermediateMemEstimate, getLength, getLops, getMemEstimate, getName, getNnz, getOutputMemEstimate, getParent, getPrivacy, getSparsity, getSpBroadcastSize, getText, getUpdateType, getValueType, hasCompressedInput, hasFederatedOutput, hasMatrixInputWithDifferentBlocksizes, hasValidCPDimsAndSize, isCompressedOutput, isFederated, isFederatedOutput, isMatrix, isMemEstimated, isOutputEmptyBlocks, isRequiredDecompression, isScalar, isTransposeSafe, isVisited, printErrorLocation, refreshColsParameterInformation, refreshColsParameterInformation, refreshMemEstimates, refreshRowsParameterInformation, refreshRowsParameterInformation, requiresCheckpoint, requiresCompression, requiresLineageCaching, requiresReblock, requiresRecompile, resetExecType, resetRecompilationFlag, resetRecompilationFlag, resetVisitStatus, resetVisitStatus, resetVisitStatus, resetVisitStatusForced, rowsKnown, setBeginColumn, setBeginLine, setBlocksize, setCompressedOutput, setCompressedSize, setDataType, setDim, setDim1, setDim2, setEndColumn, setEndLine, setExecType, setFederatedOutput, setFilename, setForcedExecType, setLops, setMemEstimate, setName, setNnz, setOutputEmptyBlocks, setParseInfo, setPrivacy, setRequiresCheckpoint, setRequiresCompression, setRequiresCompression, setRequiresDeCompression, setRequiresLineageCaching, setRequiresReblock, setRequiresRecompile, setText, setUpdateType, setValueType, setVisited, setVisited, someInputFederated, toString`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.sysds.parser.ParseInfo

      `ctxAndFilenameToParseInfo`

- - ### Constructor Detail

    - #### SpoofFusedOp

          public SpoofFusedOp()

    - #### SpoofFusedOp

          public SpoofFusedOp(String name,
                              Types.DataType dt,
                              Types.ValueType vt,
                              Class<?> cla,
                              SpoofCompiler.GeneratorAPI api,
                              String genVarName,
                              boolean dist,
                              SpoofFusedOp.SpoofOutputDimsType type)

  - ### Method Detail

    - #### checkArity

          public void checkArity()

      Description copied from class: `Hop`
      Check whether this Hop has a correct number of inputs. (Some Hops can have a variable number of inputs, such as DataOp, DataGenOp, ParameterizedBuiltinOp, ReorgOp, TernaryOp, QuaternaryOp, MultipleOp, DnnOp, and SpoofFusedOp.) Parameterized Hops (such as DataOp) can check that the number of parameters matches the number of inputs.
      Specified by:
        `checkArity` in class `Hop`

    - #### allowsAllExecTypes

          public boolean allowsAllExecTypes()

      Specified by:
        `allowsAllExecTypes` in class `Hop`

    - #### setConstDim2

          public void setConstDim2(long constDim2)

    - #### isGPUEnabled

          public boolean isGPUEnabled()

      Description copied from class: `Hop`
      In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop. Please see findExecTypeByMemEstimate for more detail. This method is necessary because not all operator are supported efficiently on GPU (for example: operations on frames and scalar as well as operations such as table).
      Specified by:
        `isGPUEnabled` in class `Hop`
      Returns:
        true if the Hop is eligible for GPU Exectype.

    - #### isMultiThreadedOpType

          public boolean isMultiThreadedOpType()

      Specified by:
        `isMultiThreadedOpType` in class `MultiThreadedHop`

    - #### constructLops

          public Lop constructLops()

      Specified by:
        `constructLops` in class `Hop`

    - #### getOpString

          public String getOpString()

      Specified by:
        `getOpString` in class `Hop`

    - #### getClassName

          public String getClassName()

    - #### refreshSizeInformation

          public void refreshSizeInformation()

      Description copied from class: `Hop`
      Update the output size information for this hop.
      Specified by:
        `refreshSizeInformation` in class `Hop`

    - #### clone

          public Object clone()
                       throws CloneNotSupportedException

      Specified by:
        `clone` in class `Hop`
      Throws:
        `CloneNotSupportedException`

    - #### compare

          public boolean compare(Hop that)

      Specified by:
        `compare` in class `Hop`

Copyright © 2021 The Apache Software Foundation. All rights reserved.